Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## avrora
Class Main

    java.lang.Object
      avrora.Main

public class Main
extends java.lang.Object

This is the main entrypoint to Avrora.

Nested Class Summary
`static class` | `Main.Action` The `Action` class defines a new action that the main driver is capable of executing.
`static class` | `Main.Location` The `Location` class encapsulates a location within a program that is specified on the command line.
`static class` | `Main.ProgramReader` The `ProgramReader` class represents an object capable of reading a program given the special command line arguments.

Field Summary
`static Option.Str` | `ACTION`
`static Option.Bool` | `BANNER`
`static Option.List` | `BRANCHCOUNTS`
`static Option.List` | `BREAKS`
`static Option.Str` | `CHIP`
`static Option.Str` | `CLASS`
`static Option.Bool` | `COLORS`
`static Verbose.Printer` | `configPrinter`
`static Option.List` | `COUNTS`
`static Option.Bool` | `CYCLES`
`static Option.Bool` | `HELP`
`static Option.Bool` | `HTML`
`static Option.Long` | `ICOUNT`
`static Option.Str` | `INPUT`
`static Option.Bool` | `LICENSE`
`static Option.Long` | `NODECOUNT`
`static Option.Str` | `OUTPUT`
`static Option.Str` | `PLATFORM`
`static Option.Bool` | `PROFILE`
`static Option.Long` | `REPEAT`
`static Option.Bool` | `TIME`
`static Option.Long` | `TIMEOUT`
`static Option.Str` | `TOPOLOGY`
`static Option.Bool` | `TOTAL`
`static Option.Bool` | `TRACE`
`static Option.List` | `VERBOSE`

Constructor Summary
`Main()`

Method Summary
`static java.util.List` | `getLocationList(Program program, java.util.List v)` The `getLocationList()` method is to used to parse a list of program locations and turn them into a list of `Main.Location` instances.
`static MicrocontrollerFactory` | `getMicrocontroller()` The `getMicrocontroller()` method is used to get the current microcontroller from the library of implemented ones, based on the command line option that was specified (-chip=xyz).
`static PlatformFactory` | `getPlatform()` The `getPlatform()` method is used to get the current platform from the library of implemented ones, based on the command line option that was specified (-platform=xyz).
`static Main.ProgramReader` | `getProgramReader()`
`static Main.ProgramReader` | `getProgramReader(java.lang.String format)`
`static void` | `main(java.lang.String[] args)`
`static void` | `parseOptions(java.lang.String[] args)` The `parseOptions()` method takes an array of strings and parses it, extracting the options and storing the option values in the internal state of main.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### INPUT

    public static final Option.Str INPUT

### ACTION

    public static final Option.Str ACTION

### OUTPUT

    public static final Option.Str OUTPUT

### BREAKS

    public static final Option.List BREAKS

### COUNTS

    public static final Option.List COUNTS

### BRANCHCOUNTS

    public static final Option.List BRANCHCOUNTS

### PROFILE

    public static final Option.Bool PROFILE

### TIME

    public static final Option.Bool TIME

### ICOUNT

    public static final Option.Long ICOUNT

### TIMEOUT

    public static final Option.Long TIMEOUT

### TOTAL

    public static final Option.Bool TOTAL

### CYCLES

    public static final Option.Bool CYCLES

### TRACE

    public static final Option.Bool TRACE

### COLORS

    public static final Option.Bool COLORS

### BANNER

    public static final Option.Bool BANNER

### VERBOSE

    public static final Option.List VERBOSE

### REPEAT

    public static final Option.Long REPEAT

### CHIP

    public static final Option.Str CHIP

### PLATFORM

    public static final Option.Str PLATFORM

### HELP

    public static final Option.Bool HELP

### CLASS

    public static final Option.Str CLASS

### LICENSE

    public static final Option.Bool LICENSE

### HTML

    public static final Option.Bool HTML

### NODECOUNT

    public static final Option.Long NODECOUNT

### TOPOLOGY

    public static final Option.Str TOPOLOGY

### configPrinter

    public static final Verbose.Printer configPrinter

Constructor Detail

### Main

    public Main()

Method Detail

### getProgramReader

    public static Main.ProgramReader getProgramReader()

### getProgramReader

    public static Main.ProgramReader getProgramReader(java.lang.String format)

### main

    public static void main(java.lang.String[] args)

### getLocationList

    public static java.util.List getLocationList(Program program,
                                                 java.util.List v)

  The `getLocationList()` method is to used to parse a list of program locations and turn them into a list of `Main.Location` instances.

  Parameters:
    `program` - the program to look up labels in
    `v` - the list of strings that are program locations
  Returns:
    a list of program locations

### getMicrocontroller

    public static MicrocontrollerFactory getMicrocontroller()

  The `getMicrocontroller()` method is used to get the current microcontroller from the library of implemented ones, based on the command line option that was specified (-chip=xyz).

  Returns:
    an instance of `MicrocontrollerFactory` for the microcontroller specified on the command line.

### getPlatform

    public static PlatformFactory getPlatform()

  The `getPlatform()` method is used to get the current platform from the library of implemented ones, based on the command line option that was specified (-platform=xyz).

  Returns:
    an instance of `PlatformFactory` for the platform specified on the command line

### parseOptions

    public static void parseOptions(java.lang.String[] args)

  The `parseOptions()` method takes an array of strings and parses it, extracting the options and storing the option values in the internal state of main.

  Parameters:
    `args` - the array of strings to parse into options

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD